Draft OrthoArray

From FreeCAD Documentation
Revision as of 07:56, 2 May 2020 by Kryptokommunist (talk | contribs) (Add description of AxisReference property)

Draft OrthoArray

Menu location
Modification → Array tools → Array
Workbenches
Draft
Default shortcut
None
Introduced in version
0.19
See also
PolarArray, CircularArray, PathArray, PointArray, Clone

Description

The Draft OrthoArray tool creates an orthogonal (3-axes) array from a selected object.

This tool can be used on 2D shapes created with the Draft Workbench but can also be used on many types of 3D objects such as those created with the Part Workbench or PartDesign Workbench. It works on all objects that have a Part TopoShape. It can also create App Links instead of simple copies.

This command deprecates the previously existing Array, as well as the short lived, LinkArray tools.

Orthogonal array from a solid object.

Usage

  1. Select an object with which you wish to make an array.
  2. Press the Draft OrthoArray button. If no object is selected, you will be invited to select one.
  3. The task panel is launched, where you can select the number of elements in each X, Y, Z direction; and the interval between each created element.
  4. Press OK to complete the operation.

Once the array in created, you can select it in the tree view, so you can change its properties in the property editor, including changing the number of the elements, or even changing its type to "polar" or "circular".

Each element in the array is an exact clone of the original object, but the entire array is considered a single unit in terms of properties and appearance.

Options

  • Interval X: the values of displacement for the copies in the X direction. To create strictly rectangular arrays, the Y and Z values should be zero (x, 0, 0).
  • Interval Y: the values of displacement for the copies in the Y direction. To create strictly rectangular arrays, the X and Z values should be zero (0, y, 0).
  • Interval Z: the values of displacement for the copies in the Z direction. To create strictly rectangular arrays, the X and Y values should be zero (0, 0, z).
  • Number of elements: the elements in the X, Y, and Z directions. A copy of the original object is produced, so this number must be at least 1 in every direction.
  • Fuse: if it is checked, the resulting objects in the array will fuse together if they touch each other. This only works if "Link array" is unchecked.
  • Link array: if it is checked, the resulting array will be a "Link array". This array internally uses App Link objects, so it is more efficient when handling many copies of complex shapes. However, in this case, the objects cannot be fused together.

Note: if a Link array is created, this object cannot be converted to a regular array. And similarly, a regular array cannot be converted to a Link array. Therefore, you must choose the type of array that you want at creation time.

Properties

Draft For all types of arrays:

  • DataArray Type (Enumeration): specifies the type of array to create, "ortho", "polar", or "circular".
  • DataBase (Link): specifies the object to duplicate in the array.
  • DataFuse (Bool): it defaults to false; if it is true, and the copies intersect with each other, they will be fused together into a single shape. This only works if the initial array was not a "Link array".

For orthogonal arrays:

  • DataInterval X (VectorDistance): specifies the interval between each copy on the X axis.
  • DataInterval Y (VectorDistance): specifies the interval between each copy on the Y axis.
  • DataInterval Z (VectorDistance): specifies the interval between each copy on the Z axis.
  • DataNumber X (Integer): specifies the number of copies on the X axis.
  • DataNumber Y (Integer): specifies the number of copies on the Y axis.
  • DataNumber Z (Integer): specifies the number of copies on the Z axis.

For polar arrays:

  • DataAngle (Angle): specifies the aperture of the circular arc to cover with copies; use 360 to cover an entire circle.
  • DataAxisReference (Link): specifies link to an edge (e.g. DatumLine) that overrides both the Axis and the Center property.
  • DataAxis (Vector): specifies the normal direction of the array circle.
  • DataCenter (VectorDistance): specifies the center point of the array circle.
  • DataInterval Axis (VectorDistance): specifies the interval between each copy on the DataAxis direction.
  • DataNumber Polar (Integer): specifies the number of copies to place in the circular arrangement.

For circular arrays:

  • DataNumber Circles (Integer): the number of circular layers to create. It must be at least one.
  • DataRadial distance (Distance): the distance from one element in a circular layer to the next element in another layer.
  • DataSymmetry (Integer): a number that indicates the symmetry lines in the circular layers. This number changes the distribution of the objects and making it very large may eliminate the central layers of copies.
  • DataTangential Distance (Distance): the distance from one element in a circular layer to the next element in the same layer.

Link arrays

In addition to the previous properties, these properties only appear when the array is created as a Link array.

Draft

  • DataCount (Integer): it is the total number of objects in the array including the original object.
  • DataExpand Array (Bool): it defaults to false; if it is true it will show every element of the array in the tree view.

Link

  • DataScale (Float): specifies the scale of the resulting array, as if it were a Clone.
  • DataLink Transform (Bool): it defaults to false if it is true, will be able to be transformed.

Notes

The number property, either in X, Y, Z, polar, or circles, also includes the original object, so this number must be at least one.

An interval is not a simple distance, but a vector (x, y, z). If more than one value is non-zero, the copy will be created in the main direction, but will also be displaced in the other non-zero directions.

For example, if DataInterval X is (2 m, 1 m, 1 m), and DataNumber X is 3, it will create 3 copies in the X direction; the first copy will be at the original position, the second will be displaced 2 m on X, 1 m on Y, and 1 m on Z; the third copy will be displaced 4 m on X, 2 m on Y, and 2 m on Z. Each array element will be moved slightly to one side (Y direction) and up (Z direction) beside the main X direction.

The DataInterval Axis property works in the same way. If the original shape lies on the XY plane, creating a polar array with DataInterval Axis (0, 0, z) allows you to make spiral arrangements.

Scripting

See also: Draft API and FreeCAD Scripting Basics.

The Array tool can be used in macros and from the Python console by using two different functions, depending on if you wish to obtain standalone copies of your base object, or a parametric array object that stays linked to the original object.

Simple array

The basic signature is as follows:

array_list = array(objectslist, arg1, arg2, arg3, arg4=None, arg5=None, arg6=None)

To create a rectangular array, use it like this:

array_list = array(objectslist, xvector, yvector, xnum, ynum)
array_list = array(objectslist, xvector, yvector, zvector, xnum, ynum, znum)

To create a polar array, use it like this:

array_list = array(objectslist, center, totalangle, totalnum)
  • Creates an array from the objects contained in objectslist, which can be a single object or a list of objects.
  • In case of a rectangular array, xvector, yvector, and zvector determine the distance between the base points of each copy, in the X, Y, and Z directions; and xnum, ynum, and znum are the number of copies in the respective direction.
  • In case of a polar array, center defines the center of the array circle, totalangle is the angle of the arc in degrees to cover with copies, and totalnum is the number of copies to arrange around the circle, including the original object.
  • array_list is returned with the new copies.
    • array_list is either a single object or a list of objects, depending on the input objectslist.

This function internally uses Draft.move() and Draft.rotate() with copy=True.

Example:

import FreeCAD, Draft

Rect = Draft.makeRectangle(1500, 500)

array_list = Draft.array(Rect, FreeCAD.Vector(1600, 0, 0), FreeCAD.Vector(0, 600, 0), 3, 4)

Parametric array

The basic signature is as follows:

Array = makeArray(baseobject, arg1, arg2, arg3, arg4=None, arg5=None, arg6=None, use_link=False)

To create a rectangular array, use it like this:

Array = makeArray(baseobject, xvector, yvector, xnum, ynum, use_link=False)
Array = makeArray(baseobject, xvector, yvector, zvector, xnum, ynum, znum, use_link=False)

To create a polar array, use it like this:

Array = makeArray(baseobject, center, totalangle, totalnum, use_link=False)
  • Creates an Array object from the given baseobject.
  • In case of a rectangular array, xvector, yvector, and zvector determine the distance between the base points of each copy, in the X, Y, and Z directions; and xnum, ynum, and znum are the number of copies in the respective direction.
  • In case of a polar array, center defines the center of the array circle, totalangle is the angle of the arc in degrees to cover with copies, and totalnum is the number of copies to arrange around the circle, including the original object.
  • If use_link is True the resulting array will be a Link array, and will have additional properties.

Example:

import FreeCAD, Draft

Rect = Draft.makeRectangle(1500, 500)
xvector = FreeCAD.Vector(1600, 0, 0)
yvector = FreeCAD.Vector(0, 600, 0)
Array = Draft.makeArray(Rect, xvector, yvector, 3, 4)

Tri = Draft.makePolygon(3, 600)
center = FreeCAD.Vector(-1600, 0, 0)
Array2 = Draft.makeArray(Tri, center, 360, 6)